#!/usr/bin/perl
############################################################
#eval {
	our $CONFIG;
	($0=~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
	($0=~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");

	include ("./config.pl");
	include ("./english.lng");
	include ("./admin.lng");

	unshift(@INC, "$CONFIG{script_path}/scripts");
	include ("./scripts/admin.pl");
	include ("./scripts/admin_gateway.pl");
	include ("./scripts/admin_html.pl");
	include ("./scripts/database.pl");
	include ("./scripts/new_database.pl");
	include ("./scripts/display.pl");
	include ("./scripts/default_config.pl");
	include ("./scripts/display.pl");
	include ("./scripts/gateway.pl");
	include ("./scripts/html.pl");
	include ("./scripts/library.pl");
	include ("./scripts/members.pl");
	include ("./scripts/mojoscripts.pl");
	include ("./scripts/parse_template.pl");
	include ("./scripts/serverinfo.pl");
	include ("./scripts/templates.pl");

	use CGI qw(:standard);
	use CGI::Carp qw(fatalsToBrowser);
   &main;
#};
#if ($@) {
#	print "content-type:text/html\n\n";
#	print "Error Including configuration file, Reason: $@";
#	exit;
#}
################################################################
sub main {
	our $exit=0;
  	$|++;
#	$Cgi = new CGI; $Cgi{mojoscripts_created} = 1;
	&ParseForm;
	$anonyminit=1;
	&Initialization;
	&BuildAdminLocation;
   if ($FORM{action} eq "login" or $FORM{'login'}) { 			&AdminLogin;		}
   elsif ($FORM{logout} or $FORM{'action'} eq 'logout') {	&AdminLogout;		}

   &CheckSession;

	my @gateways=split(/,/,$CONFIG{paymods});

	if($FORM{'type'} eq "setup"){		include ("./scripts/admin_setup.pl");			&SetupMain;		}
	elsif($FORM{'type'} eq "ad"){		include ("./scripts/admin_ads.pl");				&AdMain;			}
	elsif($FORM{'type'} eq "account" and (-f "$CONFIG{script_path}/scripts/admin_accounts.pl")){	include ("./scripts/admin_accounts.pl");	&AccountMain;	}
	elsif($FORM{'type'} eq "admin"){	include ("./scripts/admin_admin.pl");			&AdminMain;		}
	elsif($FORM{'type'} eq "debug"){	include ("./scripts/admin_debug.pl");		&DebugMain;	}
	elsif($FORM{'type'} eq "config"){	include ("./scripts/admin_setup.pl");			&SetupMain;		}
	elsif($FORM{'type'} eq "cat"){		include ("./scripts/admin_categories.pl");	&CategoryMain;	}

	elsif($FORM{'type'} eq "filetype"){	include ("./scripts/admin_filetypes.pl");		&FileTypeMain;		}
	elsif($FORM{'type'} eq "database"){	include ("./scripts/admin_database.pl");		&DatabaseMain;	}
	elsif($FORM{'type'} eq "gateway"){	include ("./scripts/admin_gateway.pl");		&GatewayMain;	}
	elsif($FORM{'type'} eq "group"){	include ("./scripts/admin_groups.pl");			&GroupMain;		}
	elsif($FORM{'type'} eq "member"){	include ("./scripts/admin_members.pl");		&MemberMain;	}
	elsif($FORM{'type'} eq "mail"){		include ("./scripts/admin_mails.pl");			&MailMain;		}
#	elsif($FORM{'type'} eq "protect"){	include ("./scripts/admin_protector.pl");		&ProtectorMain;}
#	elsif($FORM{'type'} eq "story"){	include ("./scripts/admin_story.pl");			&StoryMain;		}
	elsif($FORM{'type'} eq "security"){	include ("./scripts/admin_security.pl");		&SecurityMain;	}
	elsif($FORM{'type'} eq "template"){	include ("./scripts/admin_templates.pl");		&TemplateMain;	}
	elsif($FORM{'type'} eq "server"){	include ("./scripts/serverinfo.pl");			&ServerInfo;	}
	elsif($FORM{'type'} eq "support"){	include ("./scripts/admin_support.pl");		&SupportMain;	}
	elsif($FORM{'type'} eq "utils"){	include ("./scripts/admin_utils.pl");			&UtilsMain;		}

	elsif($FORM{'type'} eq "2checkout" and -f "$CONFIG{script_path}/scripts/admin_2checkout.pl"){	include ("./scripts/admin_2checkout.pl");		&CheckoutMain;	}
	elsif($FORM{'type'} eq "clickbank" and -f "$CONFIG{script_path}/scripts/admin_clickbank.pl"){include ("./scripts/admin_clickbank.pl");		&ClickbankMain;}
	elsif($FORM{'type'} eq "ibill" and -f "$CONFIG{script_path}/scripts/admin_ibill.pl"){		include ("./scripts/admin_ibill.pl");				&iBillMain;		}
	elsif($FORM{'type'} eq "paypal" and -f "$CONFIG{script_path}/scripts/admin_paypal.pl"){	include ("./scripts/admin_paypal.pl");				&PaypalMain;	}
	elsif($FORM{'type'} eq "mod" and -f "$CONFIG{script_path}/scripts/admin_mod.pl"){	include ("./scripts/admin_mod.pl");				&AdminModMain;	}

	elsif(-f "$CONFIG{script_path}/scripts/admin_$FORM{'type'}.pl"){	include ("./scripts/admin_$FORM{'type'}.pl");				&{(ucfirst $FORM{'type'}).'Main'};	}
	elsif(&ArrayIndex(\@gateways, $FORM{'type'})>-1 and -f "$CONFIG{script_path}/scripts/admin_$FORM{type}.pl"){
		include ("./scripts/admin_$FORM{type}.pl");
		if (defined(&{ucfirst($FORM{type})."Main"}))	{ &{ucfirst($FORM{type})."Main"};	  }
		elsif ($FORM{type} eq 'ibill') { &iBillMain;  }
		elsif ($FORM{type} eq '2checkout') { &CheckoutMain; }
  }

	elsif($FORM{'type'}){	&PrintError($mj{'error'}, $mj{'confuse'});	}
	elsif(!$exit) {&PrintAdmin;}
}
###############################################################


sub include {
        my $file=shift();
        if ($include_mode eq 'do') {do $file;} else {require $file;}
}